#! /bin/sh
# 
# $Id$
#
# Configure exim for GForge
# Christian Bayle, Roland Mas, debian-sf (GForge for Debian)

set -e

if [ $(id -u) != 0 ] ; then
    echo "You must be root to run this, please enter passwd"
    exec su -c "$0 $1"
fi

case "$1" in
    configure-files)
	# Make sure Apache sees us
	if [ -e /etc/apache/httpd.conf ] ; then
	    cp -a /etc/apache/httpd.conf /etc/apache/httpd.conf.gforge-new
	    
	    if ! grep -q "^Include /etc/gforge/httpd.conf" /etc/apache/httpd.conf.gforge-new ; then
		echo "### Next line inserted by GForge install" >> /etc/apache/httpd.conf.gforge-new
		echo "Include /etc/gforge/httpd.conf" >> /etc/apache/httpd.conf.gforge-new
	    fi
	fi

	if [ -e /etc/apache-ssl/httpd.conf ] ; then
	    cp -a /etc/apache-ssl/httpd.conf /etc/apache-ssl/httpd.conf.gforge-new
	    perl -pi -e "s/# *LoadModule php4_module/LoadModule php4_module/gi" /etc/apache-ssl/httpd.conf.gforge-new
	    perl -pi -e "s/# *LoadModule apache_ssl_module/LoadModule apache_ssl_module/gi" /etc/apache-ssl/httpd.conf.gforge-new
	    perl -pi -e "s/# *LoadModule env_module/LoadModule env_module/gi" /etc/apache-ssl/httpd.conf.gforge-new
	    perl -pi -e "s/# *LoadModule vhost_alias_module/LoadModule vhost_alias_module/gi" /etc/apache-ssl/httpd.conf.gforge-new
	    
	    if ! grep -q "^Include /etc/gforge/httpd.conf" /etc/apache-ssl/httpd.conf.gforge-new ; then
		echo "### Next line inserted by GForge install" >> /etc/apache-ssl/httpd.conf.gforge-new
		echo "Include /etc/gforge/httpd.conf" >> /etc/apache-ssl/httpd.conf.gforge-new
	    fi
	fi

	# Make sure pgsql, ldap and gd are enabled in the PHP config files
	cp -a /etc/php4/apache/php.ini /etc/php4/apache/php.ini.gforge-new
	cp -a /etc/php4/cgi/php.ini /etc/php4/cgi/php.ini.gforge-new
	if [ -f /etc/php4/apache/php.ini.gforge-new ]; then
	    if ! grep -q "^[[:space:]]*extension[[:space:]]*=[[:space:]]*pgsql.so" /etc/php4/apache/php.ini.gforge-new; then
		echo "Enabling pgsql in /etc/php4/apache/php.ini"
		echo "extension=pgsql.so" >> /etc/php4/apache/php.ini.gforge-new
	    fi
	    if ! grep -q "^[[:space:]]*extension[[:space:]]*=[[:space:]]*gd.so" /etc/php4/apache/php.ini.gforge-new; then
		echo "Enabling gd in /etc/php4/apache/php.ini"
		echo "extension=gd.so" >> /etc/php4/apache/php.ini.gforge-new
	    fi
	    if ! grep -q "^[[:space:]]*extension[[:space:]]*=[[:space:]]*ldap.so" /etc/php4/apache/php.ini.gforge-new; then
		echo "Enabling ldap in /etc/php4/apache/php.ini"
		echo "extension=ldap.so" >> /etc/php4/apache/php.ini.gforge-new
	    fi
	fi
	if [ -f /etc/php4/cgi/php.ini.gforge-new ]; then
	    if ! grep -q "^[[:space:]]*extension[[:space:]]*=[[:space:]]*pgsql.so" /etc/php4/cgi/php.ini.gforge-new; then
		echo "Enabling pgsql in /etc/php4/cgi/php.ini"
		echo "extension=pgsql.so" >> /etc/php4/cgi/php.ini.gforge-new
	    fi
	fi

	;;
    configure)
	/usr/lib/gforge/bin/prepare-vhosts-file.pl
	if [ -e /etc/apache/httpd.conf ] ; then
	    /usr/sbin/modules-config apache enable mod_php4
	    /usr/sbin/modules-config apache enable mod_ssl
	    /usr/sbin/modules-config apache enable mod_env
	    /usr/sbin/modules-config apache enable mod_vhost_alias
	fi
	if [ -e /etc/apache-perl/httpd.conf ] ; then
	    /usr/sbin/modules-config apache-perl enable mod_php4
	    /usr/sbin/modules-config apache-perl enable mod_ssl
	    /usr/sbin/modules-config apache-perl enable mod_env
	    /usr/sbin/modules-config apache-perl enable mod_vhost_alias
	fi
	if [ -e /etc/apache-ssl/httpd.conf ] ; then
	    /usr/sbin/modules-config apache-ssl enable mod_php4
	    /usr/sbin/modules-config apache-ssl enable mod_env
	    /usr/sbin/modules-config apache-ssl enable mod_vhost_alias
	fi
	if [ -x /usr/sbin/apache ]; then
		invoke-rc.d apache restart || true
	fi
	if [ -x /usr/sbin/apache-perl ]; then
		invoke-rc.d apache-perl restart || true
	fi
	if [ -x /usr/sbin/apache-ssl ]; then
		invoke-rc.d apache-ssl restart || true
	fi
	;;

    purge-files)
	cp -a /etc/apache/httpd.conf /etc/apache/httpd.conf.gforge-new
  	if grep -q "Include /etc/gforge/httpd.conf" /etc/apache/httpd.conf.gforge-new ; then
	    pattern=$(basename $0)
	    tmp=$(mktemp /tmp/$pattern.XXXXXX)
	    grep -v "Include /etc/gforge/httpd.conf\|### Next line inserted by GForge install" /etc/apache/httpd.conf.gforge-new > $tmp
	    cat $tmp > /etc/apache/httpd.conf.gforge-new
	    rm -f $tmp
  	fi
	;;
    purge)
	if [ -x /usr/sbin/apache ]; then
		invoke-rc.d apache restart || true
	fi
	if [ -x /usr/sbin/apache-perl ]; then
		invoke-rc.d apache-perl restart || true
	fi
	if [ -x /usr/sbin/apache-ssl ]; then
		invoke-rc.d apache-ssl restart || true
	fi
	;;

    *)
	echo "Usage: $0 {configure|configure-files|purge|purge-files}"
	exit 1
	;;
	
esac
